﻿Imports C1.WPF

Class MainWindow

    Private Sub Window_Loaded_1(sender As Object, e As RoutedEventArgs)
        Me.DataContext = Enumerable.Range(0, 100).[Select](Function(i) New Item() With {.Title = i.ToString()})
        tileListBox.SelectionMode = C1SelectionMode.Extended
    End Sub

#Region "** public properties"
    Public Property Orientation() As Orientation
        Get
            Return tileListBox.Orientation
        End Get
        Set(value As Orientation)
            tileListBox.Orientation = value
        End Set
    End Property

    Public Property ItemWidth() As Double
        Get
            Return tileListBox.ItemWidth
        End Get
        Set(value As Double)
            tileListBox.ItemWidth = value
        End Set
    End Property

    Public Property ItemHeight() As Double
        Get
            Return tileListBox.ItemHeight
        End Get
        Set(value As Double)
            tileListBox.ItemHeight = value
        End Set
    End Property

    Public Property ZoomMode() As ZoomMode
        Get
            Return tileListBox.ZoomMode
        End Get
        Set(value As ZoomMode)
            tileListBox.ZoomMode = value
        End Set
    End Property
#End Region

    Dim sitem As C1.WPF.C1ListBoxItem

    Private Sub tileListBox_ItemClick(sender As Object, e As EventArgs) Handles tileListBox.ItemClick
        sitem = sender
    End Sub

   Dim flag As Boolean = False

    Private Sub tileListBox_MouseLeftButtonUp(sender As Object, e As MouseButtonEventArgs) Handles tileListBox.MouseLeftButtonUp
        Dim index As Integer = tileListBox.GetIndexAt(e.GetPosition(tileListBox))
        Dim obj As Item = CType(tileListBox.Items(index), Item)

        Dim lst As List(Of Object) = CType(tileListBox.SelectedItems, Object()).ToList()

        If Keyboard.IsKeyDown(Key.LeftCtrl) Or Keyboard.IsKeyDown(Key.RightCtrl) Then
            lst.Add(obj)
            flag = True
        Else
           lst.Add(obj)
            If flag = True Then
                lst.Clear()
                flag = False
            End If
        End If
        tileListBox.SelectedItems = lst.ToArray()
    End Sub

    Private Sub tileListBox_PreviewMouseRightButtonDown(sender As Object, e As MouseButtonEventArgs) Handles tileListBox.PreviewMouseRightButtonDown
        e.Handled = True
    End Sub

End Class

Public Class Item
    Public Property Title() As String
        Get
            Return m_Title
        End Get
        Set(value As String)
            m_Title = value
        End Set
    End Property

    Private m_Title As String
    Public Property Thumbnail() As String
        Get
            Return m_Thumbnail
        End Get
        Set(value As String)
            m_Thumbnail = value
        End Set
    End Property

    Private m_Thumbnail As String

End Class
